import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class bandas extends PApplet {

PImage backgnd;
int dontLeaveMeNow = 0; // Controla as screens

int waitingForTheWorms = 0; //Little joke
PImage vera;

public void setup() {
  size(800, 600);
  
  backgnd = loadImage("back.jpg");
  
  // Bandas e mascara
  
  anotherBrickInTheWall_1 = loadImage("bands.png");
  outsideTheWall = loadImage("bands_mask.png"); 
  
  // Creditos
  
  for (int i = 0; i < 3; i++)
    credits[i] = loadImage("credit" + i + ".png");

  // Instrucoes
  
  for (int i = 0; i < 3; i++)
    instruct[i] = loadImage("instru" + i + ".png");
    
  heyYou = loadImage("hey_you.png");
  
  // Explicacao
  
  anotherBrickInTheWall_2 = loadImage("brick2.png");
  for (int i = 0; i < mother.length; i++)
    mother[i] = loadImage("mother" + i + ".png");
  
  theHappiestDayOfOurLives = loadImage("happiest_day.png");
  
    // Botoes da explicacao
    
    theShowMustGoOn[0] = loadImage("next0.png");
    theShowMustGoOn[1] = loadImage("next1.png");
    theShowMustGoOn[2] = loadImage("next2.png");
    
    bringTheBoysBackHome[0] = loadImage("back0.png");
    bringTheBoysBackHome[1] = loadImage("back1.png");
    bringTheBoysBackHome[2] = loadImage("back2.png");
    
  
  // Slider
  
  anotherBrickInTheWall_3[0] = loadImage("brick3.png");
  anotherBrickInTheWall_3[1] = loadImage("colored_brick3.png");
  anotherBrickInTheWall_3[2] = loadImage("round_brick3.png");
    
  // Criacao dos portadores. As posicoes sao proporcionais aos indices de uma matriz
  
  eletron = loadImage("eletron.png");  
  hole = loadImage("hole.png");
  
  for (int i = 0; i < 9; i++) {
    comfortablyNumb[i] = new chargeCarriers(i*22 + 143, 360, random(0.1f, 2.0f), -1);
    comfortablyNumb[i+9] = new chargeCarriers(i*22 + 143, 382, random(0.1f, 2.0f), -1);
    comfortablyNumb[i+18] = new chargeCarriers(i*22 + 143, 404, random(0.1f, 2.0f), -1);
    
    theThinIce[i] = new chargeCarriers(i*22 + 143, 240, 0, -1);
    theThinIce[i+9] = new chargeCarriers(i*22 + 143, 218, 0, -1);
    theThinIce[i+18] = new chargeCarriers(i*22 + 143, 196, 0, -1);
  }

  // Info de fundo 
  
  theWall = loadImage("wall.png");
  vera = loadImage("vera.png");
}

public void draw() {
  println(waitingForTheWorms);
  println(mouseX);
  println(mouseY);
  
  image(outsideTheWall, 120, 177);
  
  background(backgnd);
  noStroke();
  
  switch(dontLeaveMeNow) {
    case 0: drawBands(); break;
    case 1: image(theHappiestDayOfOurLives, 0, 0); break;
    case 2: image(heyYou, 0, 0); break;
  }
  
}

public void mousePressed() {
  
  // Slider
  
  if (sqrt(sq((mouseX  - 138) - youngLust) + sq(mouseY  - 458)) < 8)
    isClicked = true;
  
  // Botoes da explicacao
  
  if (mouseX > 725 && mouseX < 747 && mouseY > 390 && mouseY < 412 && mother_count < 5) {
      image(theShowMustGoOn[2], 725, 390);
      mother_count++;
      if (mother_count > 5)
        mother_count = 5;
  }
  
  if (mouseX > 695 && mouseX < 717 && mouseY > 390 && mouseY < 412 && mother_count > 0) {
      image(bringTheBoysBackHome[2], 695, 390);
      mother_count--;
      if (mother_count < 0)
        mother_count = 0;
  }
  
  // Creditos
  
  if (mouseX > 123 && mouseX < 226 && mouseY > 10 && mouseY < 32) {
    image(credits[2], 123, 10);
    dontLeaveMeNow = 1;
  }
  
  if (dontLeaveMeNow == 1) {
    if (mouseX <= 695 && mouseX >= 673 && mouseY >= 55 && mouseY <= 73)
      dontLeaveMeNow = 0;
  }
  
  // Instrucoes
  
  if (mouseX > 10 && mouseX < 113 && mouseY > 10 && mouseY < 32) {
    image(instruct[2], 10, 10);
    dontLeaveMeNow = 2;
  }
  
  if (mouseX <= 795 && mouseX >= 773 && mouseY >= 5 && mouseY <= 23 && dontLeaveMeNow == 2)
    dontLeaveMeNow = 0;
  
  if (mouseY > 590)
    waitingForTheWorms++;
}

public void mouseDragged() {
  if (isClicked && mouseX > 138 && mouseX < 327)
    youngLust = PApplet.parseFloat(mouseX) - 138;
}

public void mouseReleased() {
  if (isClicked)
    isClicked = false;
}
// Botoes instrucoes e creditos

PImage[] instruct =  new PImage[3];
PImage heyYou; // Hey You! Do exactly as I say! =)

PImage[] credits = new PImage[3];
PImage theHappiestDayOfOurLives; // I'm really happy and thankful for all this time together [?]

PImage anotherBrickInTheWall_1, outsideTheWall; // Bandas e mascara das bandas
PImage theWall;
PImage eletron, hole;

PImage[] mother = new PImage[6]; // Explicacoes, que vao *ensinar* (demais essa)
int mother_count = 0;
PImage anotherBrickInTheWall_2; // Quadro da explicacao

PImage[] anotherBrickInTheWall_3 = new PImage[3]; // Slider
boolean isClicked = false; // Variavel do slider

// Imagens dos botoes

PImage[] theShowMustGoOn = new PImage[3]; // goes on in the explanation
PImage[] bringTheBoysBackHome = new PImage[3]; // goes back
int[] offset = {0, 0, 0}; //0: setas da explicacao, 1: botao instrucoes, 2: botao creditos

float oneOfMyTurns; // Probabilidade de um eletron mudar de posicao na b. de valencia. Quanto mais *louco*, maior a probabilidade
chargeCarriers[] theThinIce = new chargeCarriers[27]; // eletrons em estado *instavel* (alta energia), na b. de conducao
chargeCarriers[] comfortablyNumb = new chargeCarriers[27];  // eletrons em estado *estavel* (baixa energia), na b. de valencia
//chargeCarriers waitingForTheWorms; // auxiliar, pra poder fazer a troca

int isThereAnybodyOutThere = -1; // Diz quantos eletrons ja foram para a b. de conducao
float youngLust = 0; // Variavel para o usuario controlar a *energia*
float e1; // Variavel temporaria que recebe a energia de um eletron

int switch_index;
boolean Stop = false;

public void drawBands() {
  
  image(theWall, 0, 80);
  
  // Mudar tamb\u00e9m a posicao da mascara e dos eletrons
  image(anotherBrickInTheWall_1, 120, 177);
  
  // Botoes dos creditos e das instrucoes

  tint(255, offset[1]);
  image(instruct[1], 10, 10);
    
  tint(255, offset[2]);
  image(credits[1], 123, 10);
    
  noTint();
    
  image(instruct[0], 10, 10);
  image(credits[0], 123, 10);
  
  if (mouseX > 10 && mouseX < 113 && mouseY > 10 && mouseY < 32)
    tintPlus(1);
  else
    tintSubt(1);
    
  if (mouseX > 123 && mouseX < 226 && mouseY > 10 && mouseY < 32)
    tintPlus(2);
  else
    tintSubt(2);
  
  // Explicacao
  
  image(anotherBrickInTheWall_2, 495, 177);
  image(mother[mother_count], 495, 177);

    tint(255, offset[0]);
    if (mouseX > 495 && mouseX < 761 && mouseY > 177 && mouseY < 425)
      tintPlus(0);
    else
      tintSubt(0);
    
    if (mother_count < 5) {
      if (mouseX > 725 && mouseX < 747 && mouseY > 390 && mouseY < 412)
        image(theShowMustGoOn[1], 725, 390);
      else
        image(theShowMustGoOn[0], 725, 390);
    }
    
    if (mother_count > 0) {
      if (mouseX > 695 && mouseX < 717 && mouseY > 390 && mouseY < 412)
        image(bringTheBoysBackHome[1], 695, 390);
      else
        image(bringTheBoysBackHome[0], 695, 390);
    }
    noTint();
    
    pushMatrix();
    translate(120, 440);
      image(anotherBrickInTheWall_3[0], 0, 0);
      image(anotherBrickInTheWall_3[1], 11, 15, youngLust, anotherBrickInTheWall_3[1].height);
      image(anotherBrickInTheWall_3[2], youngLust + 10, 10);
    popMatrix();
    
  
  // Movimentacao eletronica
  
    for (int i = 0; i < comfortablyNumb.length; i++) {
//    
//    if (comfortablyNumb[i].nobodyHome == 0) {
//      switch_index = theTrial(i);
//      
//      if (oneOfMyTurns > 0.8 && switch_index != -1 && !Stop) {
////        waitingForTheWorms = comfortablyNumb[i];
////        comfortablyNumb[i] = comfortablyNumb[switch_index];
////        comfortablyNumb[switch_index] = waitingForTheWorms;
//        
//        comfortablyNumb[switch_index].chargeSetter(-1);
//        comfortablyNumb[i].chargeSetter(1);
//        
//        Stop = true;
//        
//        fill(0);
//        ellipse(mouseX, mouseY, 10, 10);
//      }
//    }
    
    oneOfMyTurns = comfortablyNumb[i].energy/(comfortablyNumb[i].energy/100 + random(0,1000));
    comfortablyNumb[i].inTheFlesh(youngLust/70);
        
    comfortablyNumb[i].runLikeHell();
    
    if (i <= isThereAnybodyOutThere) {
      theThinIce[i].runLikeHell();
      
      e1 = comfortablyNumb[i].inTheFleshS();
      theThinIce[i].inTheFlesh(e1);
    }
    
    // Valencia > Conducao
    
    if (comfortablyNumb[i].inTheFleshS() > 2.5f && comfortablyNumb[i].nobodyHome == 0)
      comfortablyNumb[i].goodbyeCruelWorld();
    
    // Conducao > Valencia
    
    if (comfortablyNumb[i].inTheFleshS() < 2.5f && comfortablyNumb[i].nobodyHome == 1)
      comfortablyNumb[emptySpaces()].goodbyeBlueSky();

//    fill(0);
//    text(isThereAnybodyOutThere, mouseX, mouseY);

  }
  
  Stop = false; 
  
  pushMatrix();
  resetMatrix();
  if (mouseY < 590)
    image(eletron, 0, 585, 20, 20);
  else
    image(hole, 0, 585, 20, 20);
  if (waitingForTheWorms > 10 && waitingForTheWorms < 12)
    image(vera, 0, 130, 800, 340);
  if (waitingForTheWorms >= 12)
    waitingForTheWorms = 0;
    
  popMatrix();
}

// Funcao que diz onde h\u00e1 *lacunas* na b. de valencia

public int emptySpaces() {  
  for (int j = 0; j < comfortablyNumb.length; j++)
    if (comfortablyNumb[j].nobodyHome == 1)
      return j;
  return 0;
}

// Controla o movimento dos eletrons em regioes adjacentes e impoe qual a nova posicao

public int theTrial(int index) {

  int[] adjc = new int[8];
  
  adjc[0] = index - 10; adjc[1] = index - 9; adjc[2] = index - 8; adjc[3] = index - 1; adjc[4] = index + 1; adjc[5] = index + 8; adjc[6] = index + 9; adjc[7] = index + 10;
  
  for (int i = 0; i < adjc.length && !Stop; i++) {
    if (adjc[i] > 0 && adjc[i] < 26) {
      if (comfortablyNumb[adjc[i]].nobodyHome == 1)
        return adjc[i];
    }
  }
  
  return -1;
}

public void tintPlus(int x) {
  offset[x] += 15;
  if (offset[x] > 255)
    offset[x] = 255;
}

public void tintSubt(int x) {
  offset[x] -= 15;
  if (offset[x] < 0)
    offset[x] = 0;
}
class chargeCarriers {
  float px;
  float py;  
  float energy;
  float energy0;
  int charge;
  float lock_x;
  float lock_y;
  
  // Variaveis [especiais] para controle da posicao dos portadores.
  
  int nobodyHome = 0; // 1 se for lacuna
  
  chargeCarriers (float t_px, float t_py, float t_energy, int t_charge) {
      px = lock_x = t_px;
      py = lock_y = t_py;
      
      charge = t_charge;
      
      energy = energy0 = t_energy;
  }
  
  // Metodos da classe =)
  
   public void runLikeHell() {
     
       px = lock_x + random(-energy, energy);
       py = lock_y + random(-energy, energy);
         
     if (abs(px - lock_x) > 5)
       px = lock_x;
       
     if (abs(py - lock_y) > 5)
       py = lock_y;
     
     imageMode(CENTER);
     switch (charge) {
       case -1: image(eletron, px, py); break;
       case 1: image(hole, px, py); break;       
     }
      
     imageMode(CORNER);
   }
   
   // Getter da energia na *carne* do eletron - Essa eu viajei mesmo
   
   public float inTheFleshS() {
     return energy;
   }
   
   // Setter da energia na *carne* do eletron
   
   public void inTheFlesh(float _energy) {
     energy = energy0 + _energy;
   }

   // Leva os eletrons para a b. de conducao
   
   public void goodbyeCruelWorld() {
     isThereAnybodyOutThere++;
     charge = 1;
     nobodyHome = 1;
   }
   
   // Traz os eletrons de volta para a b. de valencia
   
   public void goodbyeBlueSky() {
     isThereAnybodyOutThere--;
     charge = -1;
     nobodyHome = 0;
   }
   
   public void nobodyHomeSetter(int x) {
     nobodyHome = x;
   }
     
   public void chargeSetter(int _c) {
     charge = _c;
   }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "bandas" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
